<template>
  <div class="result" :class="textClass">
    <Icon :icon="icon" :class="colorClass" />
    {{status}}
  </div>
</template>

<script setup>
import { defineProps, ref, watch } from "vue";
const { status } = defineProps({
  status: String,
});
const icon = ref('');
const colorClass = ref({});
const textClass = ref({});

const updateState = (newState) => {
  icon.value = newState === 'passed' ? 'ooui:check' : 'ooui:not-bright';
  const name = newState.replace(' ', '_').toLowerCase();
  colorClass.value = 'icon-' + name;
  textClass.value = 'text-' + name;
};

updateState(status);
watch(() => status.value, updateState);
</script>

<style scoped>
.result {
  display: flex;
  align-items: center;
  white-space: nowrap;
  gap: 0.4em;
}

.icon-passed, .icon-running, .text-running {
  color: green;
}

.icon-failed {
  color: red;
}

.icon-paused, .text-paused {
  color: #9E8E3B;
}

.icon-stopped, .text-stopped {
  color: red;
}

.icon-in_progress {
  color: gray;
}

.text-in_progress {
  font-style: italic;
}
</style>
